=== debian/changelog ===
obs-advanced-scene-switcher (1.26.4-1~bpo12+1) bookworm-backports; urgency=medium

  * Team upload.
  * Rebuild for bookworm-backports.
  * Remove t64 logic from d/rules.

 -- Tobias Frost <tobi@debian.org>  Thu, 25 Jul 2024 09:49:27 +0200

obs-advanced-scene-switcher (1.26.4-1) unstable; urgency=medium

  * New upstream version 1.26.4.
  * debian/patches/010_fix-FTBFS-i386.patch: created to fix a FTBFS in i386
    and other architectures. Thanks to WarmUpTill (upstream).

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 14 Jun 2024 23:27:15 -0300

obs-advanced-scene-switcher (1.26.2-1) unstable; urgency=medium

  * New upstream version 1.26.2.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 22 May 2024 14:19:43 -0300

obs-advanced-scene-switcher (1.26.1-1) unstable; urgency=medium

  * New upstream version 1.26.1.
  * debian/clean: created to remove a file forgotten by the upstream after
    clean.
  * debian/copyright: updated some upstream rights.
  * debian/patches/010_fix-cmake.patch: removed because the upstream applied
    this patch. Thanks!

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 13 May 2024 10:46:31 -0300

obs-advanced-scene-switcher (1.25.5-1) unstable; urgency=medium

  * New upstream version 1.25.5.
  * Fixed a dependency of old libcurl. Consequently:
      - debian/control: dropped libcurl from Depends field from the binary
        obs-advanced-scene-switcher.
      - debian/rules: added the target override_dh_gencontrol to select a right
        libcurl from the system.
      - Thanks to Matthias Klose <doko@ubuntu.com>. (Closes: #1068414)
  * debian/control: updated Build-Depends field:
      - Added libxkbcommon-dev and nlohmann-json3-dev.
      - Replaced qtbase5-dev by qt6-base-dev.
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/patches/010_fix-cmake.patch: created to make building process
    compliant with Debian. Thanks to WarmUpTill <WarmUpTill@web.de>.
  * debian/rules:
      - Removed a workaround no longer needed about libremidi.
      - Removed no longer needed 'export QT_SELECT = qt5'.
  * debian/tests/control: added a workaround to ignore a false positive
    message 'Tried to call obs_frontend_add_event_callback with no callbacks'.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 23 Apr 2024 18:35:29 -0300
