## obs-advanced-scene-switcher 1.28.1

=== debian/changelog ===
obs-advanced-scene-switcher (1.28.1-1) unstable; urgency=medium

  * New upstream version 1.28.1.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 06 Nov 2024 19:14:01 -0300

obs-advanced-scene-switcher (1.27.2-1) unstable; urgency=medium

  * New upstream version 1.27.2.
  * debian/control: bumped Standards-Version to 4.7.0.
  * debian/patches/010_fix-FTBFS-i386.patch: removed because this patch was
    provided by the upstream and it is already applied in current version.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 05 Sep 2024 13:03:01 -0300
