=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                libwebsocketpp-dev,
                nlohmann-json3-dev,
                qt6-base-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://obsproject.com/forum/resources/advanced-scene-switcher.395/
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/obs-advanced-scene-switcher
