## obs-advanced-scene-switcher 1.29.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,12 @@
   include(helpers)
 endif()
 
+# OBS 31 no longer defines find_qt so check if we need to include it for in-tree
+# builds
+if(NOT COMMAND find_qt)
+  include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/common/helpers_common.cmake")
+endif()
+
 set(LIB_NAME "${PROJECT_NAME}-lib")
 add_library(${PROJECT_NAME} MODULE)
 add_library(${LIB_NAME} SHARED)
@@ -52,8 +58,6 @@
   ${LIB_NAME}
   PRIVATE lib/legacy/scene-group.cpp
           lib/legacy/scene-group.hpp
-          lib/legacy/scene-trigger.cpp
-          lib/legacy/scene-trigger.hpp
           lib/legacy/switch-audio.cpp
           lib/legacy/switch-audio.hpp
           lib/legacy/switch-executable.cpp
@@ -66,8 +70,6 @@
           lib/legacy/switch-idle.hpp
           lib/legacy/switch-media.cpp
           lib/legacy/switch-media.hpp
-          lib/legacy/switch-network.cpp
-          lib/legacy/switch-network.hpp
           lib/legacy/switch-pause.cpp
           lib/legacy/switch-pause.hpp
           lib/legacy/switch-random.cpp
@@ -96,6 +98,8 @@
           lib/macro/macro-action-macro.hpp
           lib/macro/macro-action-queue.cpp
           lib/macro/macro-action-queue.hpp
+          lib/macro/macro-action-script.cpp
+          lib/macro/macro-action-script.hpp
           lib/macro/macro-action-variable.cpp
           lib/macro/macro-action-variable.hpp
           lib/macro/macro-action.cpp
@@ -108,6 +112,8 @@
           lib/macro/macro-condition-macro.hpp
           lib/macro/macro-condition-queue.cpp
           lib/macro/macro-condition-queue.hpp
+          lib/macro/macro-condition-script.cpp
+          lib/macro/macro-condition-script.hpp
           lib/macro/macro-condition-tempvar.cpp
           lib/macro/macro-condition-tempvar.hpp
           lib/macro/macro-condition-variable.cpp
@@ -128,10 +134,14 @@
           lib/macro/macro-ref.hpp
           lib/macro/macro-run-button.cpp
           lib/macro/macro-run-button.hpp
+          lib/macro/macro-script-handler.cpp
+          lib/macro/macro-script-handler.hpp
           lib/macro/macro-segment-copy-paste.cpp
           lib/macro/macro-segment-copy-paste.hpp
           lib/macro/macro-segment-list.cpp
           lib/macro/macro-segment-list.hpp
+          lib/macro/macro-segment-script.cpp
+          lib/macro/macro-segment-script.hpp
           lib/macro/macro-segment-selection.cpp
           lib/macro/macro-segment-selection.hpp
           lib/macro/macro-segment.cpp
@@ -153,14 +163,22 @@
           lib/queue/action-queue.hpp
           lib/queue/action-queue-tab.cpp
           lib/queue/action-queue-tab.hpp
+          lib/utils/auto-update-tooltip-label.cpp
+          lib/utils/auto-update-tooltip-label.hpp
           lib/utils/backup.cpp
           lib/utils/backup.hpp
+          lib/utils/condition-logic.cpp
+          lib/utils/condition-logic.hpp
           lib/utils/curl-helper.cpp
           lib/utils/curl-helper.hpp
+          lib/utils/cursor-shape-changer.cpp
+          lib/utils/cursor-shape-changer.hpp
           lib/utils/double-slider.cpp
           lib/utils/double-slider.hpp
           lib/utils/duration-control.cpp
           lib/utils/duration-control.hpp
+          lib/utils/duration-modifier.cpp
+          lib/utils/duration-modifier.hpp
           lib/utils/duration.cpp
           lib/utils/duration.hpp
           lib/utils/export-symbol-helper.hpp
@@ -174,6 +192,8 @@
           lib/utils/item-selection-helpers.hpp
           lib/utils/layout-helpers.cpp
           lib/utils/layout-helpers.hpp
+          lib/utils/list-controls.cpp
+          lib/utils/list-controls.hpp
           lib/utils/list-editor.cpp
           lib/utils/list-editor.hpp
           lib/utils/log-helper.cpp
@@ -188,7 +208,6 @@
           lib/utils/name-dialog.hpp
           lib/utils/non-modal-dialog.cpp
           lib/utils/non-modal-dialog.hpp
-          lib/utils/obs-dock.hpp
           lib/utils/obs-module-helper.cpp
           lib/utils/obs-module-helper.hpp
           lib/utils/path-helpers.cpp
@@ -197,6 +216,9 @@
           lib/utils/plugin-state-helpers.hpp
           lib/utils/priority-helper.cpp
           lib/utils/priority-helper.hpp
+          lib/utils/properties-view.cpp
+          lib/utils/properties-view.hpp
+          lib/utils/properties-view.moc.hpp
           lib/utils/regex-config.cpp
           lib/utils/regex-config.hpp
           lib/utils/resizing-text-edit.cpp
@@ -237,12 +259,16 @@
           lib/utils/tab-helpers.hpp
           lib/utils/temp-variable.cpp
           lib/utils/temp-variable.hpp
+          lib/utils/time-helpers.cpp
+          lib/utils/time-helpers.hpp
           lib/utils/ui-helpers.cpp
           lib/utils/ui-helpers.hpp
           lib/utils/utility.cpp
           lib/utils/utility.hpp
           lib/utils/volume-control.cpp
           lib/utils/volume-control.hpp
+          lib/utils/websocket-api.cpp
+          lib/utils/websocket-api.hpp
           lib/variables/variable-line-edit.cpp
           lib/variables/variable-line-edit.hpp
           lib/variables/variable-number.hpp
@@ -260,13 +286,25 @@
 
 # --- End of section ---
 
+# Subfolder for advanced scene switcher plugins
+set(ADVSS_PLUGIN_FOLDER "advanced-scene-switcher-plugins")
+target_compile_definitions(
+  ${LIB_NAME} PRIVATE ADVSS_PLUGIN_FOLDER=\"${ADVSS_PLUGIN_FOLDER}\")
+
 include(cmake/common/advss_helpers.cmake)
 setup_obs_lib_dependency(${LIB_NAME})
 setup_obs_lib_dependency(${PROJECT_NAME})
 
-find_qt(COMPONENTS Widgets Core)
-target_link_libraries(${PROJECT_NAME} PRIVATE Qt::Core Qt::Widgets)
-target_link_libraries(${LIB_NAME} PRIVATE Qt::Core Qt::Widgets)
+find_package(Qt6 REQUIRED COMPONENTS Widgets Core)
+target_link_libraries(${PROJECT_NAME} PRIVATE Qt6::Core Qt6::Widgets)
+target_link_libraries(${LIB_NAME} PRIVATE Qt6::Core Qt6::Widgets)
+
+# Ignore QCheckBox::stateChanged deprecation warning until minimum supported Qt
+# version is at least Qt 6.7, which introduces QCheckBox::checkStateChanged
+if(Qt6_VERSION VERSION_GREATER "6.0.0")
+  target_compile_definitions(${LIB_NAME} PRIVATE QT_NO_DEPRECATED_WARNINGS)
+endif()
+
 target_compile_options(
   ${PROJECT_NAME}
   PRIVATE
@@ -286,45 +324,3 @@
   ${LIB_NAME}
   PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/lib"
           "${CMAKE_CURRENT_SOURCE_DIR}/lib/legacy"
-          "${CMAKE_CURRENT_SOURCE_DIR}/lib/macro"
-          "${CMAKE_CURRENT_SOURCE_DIR}/lib/queue"
-          "${CMAKE_CURRENT_SOURCE_DIR}/lib/utils"
-          "${CMAKE_CURRENT_SOURCE_DIR}/lib/variables"
-          "${CMAKE_CURRENT_BINARY_DIR}/forms")
-
-set_target_properties(
-  ${LIB_NAME}
-  PROPERTIES AUTOMOC ON
-             AUTOUIC ON
-             AUTORCC ON
-             AUTOUIC_SEARCH_PATHS "${CMAKE_CURRENT_SOURCE_DIR}/forms")
-set_target_properties(${LIB_NAME} PROPERTIES CXX_VISIBILITY_PRESET hidden)
-
-target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)
-target_compile_features(${LIB_NAME} PUBLIC cxx_std_17)
-
-add_definitions(-DASIO_STANDALONE)
-target_include_directories(
-  ${LIB_NAME}
-  PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/deps/asio/asio/include"
-         "${CMAKE_CURRENT_SOURCE_DIR}/deps/websocketpp"
-         "${CMAKE_CURRENT_SOURCE_DIR}/deps/obs-websocket/lib"
-         "${CMAKE_CURRENT_SOURCE_DIR}/deps/exprtk")
-
-if(NOT nlohmann_json_DIR
-   AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/deps/json/CMakeLists.txt")
-  add_subdirectory(deps/json)
-else()
-  find_package(nlohmann_json REQUIRED)
-endif()
-target_link_libraries(${LIB_NAME} PUBLIC nlohmann_json::nlohmann_json)
-
-find_package(CURL QUIET)
-find_package(Libcurl QUIET)
-if(CURL_FOUND)
-  if(NOT DEFINED CURL_INCLUDE_DIRS AND TARGET CURL::libcurl)
-    get_target_property(CURL_INCLUDE_DIR CURL::libcurl
-                        INTERFACE_INCLUDE_DIRECTORIES)
-    target_include_directories(${LIB_NAME} PUBLIC "${CURL_INCLUDE_DIR}")
-  else()
-    target_include_directories(${LIB_NAME} PUBLIC "${CURL_INCLUDE_DIRS}")
