=== plugins/base/CMakeLists.txt ===
--- 
+++ 
@@ -89,6 +89,8 @@
           macro-condition-filter.hpp
           macro-condition-folder.cpp
           macro-condition-folder.hpp
+          macro-condition-game-capture.cpp
+          macro-condition-game-capture.hpp
           macro-condition-hotkey.cpp
           macro-condition-hotkey.hpp
           macro-condition-idle.cpp
@@ -117,6 +119,8 @@
           macro-condition-scene-visibility.hpp
           macro-condition-scene.cpp
           macro-condition-scene.hpp
+          macro-condition-screenshot.cpp
+          macro-condition-screenshot.hpp
           macro-condition-slideshow.cpp
           macro-condition-slideshow.hpp
           macro-condition-source.cpp
@@ -172,6 +176,8 @@
           utils/striped-frame.hpp
           utils/text-helpers.cpp
           utils/text-helpers.hpp
+          utils/transform-setting.cpp
+          utils/transform-setting.hpp
           utils/transition-selection.cpp
           utils/transition-selection.hpp
           utils/websocket-helpers.cpp
