=== debian/changelog ===
obs-advanced-scene-switcher (1.29.1-1) unstable; urgency=medium

  * New upstream version 1.29.1. (Closes: #1099962)
  * debian/control:
      - Added libusb-1.0-0-dev to Build-Depends field.
      - Bumped Standards-Version to 4.7.2.
  * debian/copyright: updated upstream and packaging copyright years.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 23 Mar 2025 15:35:46 -0300
